package ex5.backend;

import java.util.Vector;
import java.util.Iterator;


public class MyPortfolioView implements PortfolioView {
  private Vector folio;
  private String name;
  
  public MyPortfolioView(String pf, PortfolioActionHandler pah) {

    /* folio = pah.getPortfolio(pf);
    if (folio != null) {
      
      name = (String)folio.elementAt(0); // get name and move it.
      folio.remove(0);
      } */
  }

  public int numStocks() {
    return (folio.size() - 1);
  }
  public String getName() {
    return name;
  }

  public String getTicker(int index) {
    return ((Stock) folio.elementAt(index + 1)).getTicker();
  }

  public int getShares(int index) {
    return ((Stock) folio.elementAt(index + 1)).getShares();
  }

  public float getPrice(int index) {
    return ((Stock) folio.elementAt(index + 1)).getPrice();
  }

  
  protected MyPortfolioView(Vector portfolio) {
    name = (String)portfolio.elementAt(0);
    folio = portfolio;
  }

  // iterator of stocks
  public Iterator getIterator() {
    Iterator temp = folio.iterator();
    temp.next(); // skip name
    return temp;
    
  }
}  
