// comments.. hmm..
// i hope the many lines don't cause this to explode on the laptop.
// i looked at a bezier curve demo applet to figure out how to
// make the curve - it was really cool..
// http://www.math.ucla.edu/~baker/java/hoefer/Bezier.htm

// the rectangles approximately follow the curve.
// i really like the effect of dark rectangles behind the curve.

// mx - stability/ my - symmetry

import java.awt.*;
public class catherine_ps5_p1 extends mas110panel {
  Color black = new Color(0,0,0);
  Color white = new Color(1f, 1f,1f);

   public void draw(Graphics g, float t) {

     int tpta = 0;
     float tpt;
     float ratio = (float)Math.PI/2.5f;

     float newt = t%2.5f;

     float x, y;

     float x0 = (float)(10+my*40*Math.cos(newt*ratio)+50*Math.sin(newt*ratio));
     float x1 = (float)(w*(1-my)*(1-mx*Math.cos(newt*ratio))+8*my);
     float x2 = (float)(w*(1-my*my)+(my*my)*(35*newt-87*mx)-40*my*mx*Math.cos(newt*ratio));
     float x3 = (float)(10+50*Math.sin(newt*ratio)+50*Math.cos(2*newt*ratio)*my);;

     float y0 = (float)(h/4f+5*Math.cos(newt*ratio)*my-20*my*mx*Math.sin(newt*ratio));
     float y1 = (float)(h*(1-my)+(my)*(1+Math.sin(newt*my*ratio))*(Math.cos(mx*newt*ratio))+Math.sin(my)*mx*newt*40);
     float y2 = (float)(h*newt*my+my*(1-mx)*40);
     float y3 = (float)(3*h/4f+5*Math.cos(newt*ratio)*my);;


     float lastx, lasty;

     g.setColor(black);
     g.fillRect(0,0,w,h);

     x = (1-newt)*(1-newt)*(1-newt)*x0 + 3*(1-newt)*(1-newt)*newt*x1 + 
       3*(1-newt)*newt*newt*x2 + newt*newt*newt*x3;
     
     y = (1-newt)*(1-newt)*(1-newt)*y0 + 3*(1-newt)*(1-newt)*newt*y1 + 
       3*(1-newt)*newt*newt*y2 + newt*newt*newt*y3;
    
     g.setColor(new Color(.14f, .14f, .14f));
     g.fillRect((int)(x+10+Math.sin(ratio*newt)*mx*15),(int)y+20, 40, 20);

     g.setColor(new Color(.1f*newt, .1f*newt, .1f*newt));
     g.fillRect((int)(x0+7),(int)(y0+20*(1-my)-my*30*Math.sin(newt*ratio)), 22, 33);

     g.setColor(new Color(.67f, .67f, .67f));
     g.drawRect((int)(x0+5),(int)(y0-5+10*(1-my)), 22, 33);

     g.setColor(new Color(.37f, .37f, .37f));
     g.drawRect((int)(y0*mx+30-15*mx*newt),(int)(x0-5+10*(1-newt*mx)), 30, 10);


     
     g.setColor(white);

       lastx = x0;

       lasty = y0;

       //hopefully 40 lines won't kill the laptop..
     for (tpta = 0; tpta < 40; tpta++) {
       tpt = tpta/40f;

       g.setColor(new Color(tpt*tpt*.5f+.5f, .5f+.5f*tpt*tpt, .5f+.5f*tpt*tpt));

       x = (1-tpt)*(1-tpt)*(1-tpt)*x0 + 3*(1-tpt)*(1-tpt)*tpt*x1 + 
	 3*(1-tpt)*tpt*tpt*x2 + tpt*tpt*tpt*x3;

       y = (1-tpt)*(1-tpt)*(1-tpt)*y0 + 3*(1-tpt)*(1-tpt)*tpt*y1 + 
	 3*(1-tpt)*tpt*tpt*y2 + tpt*tpt*tpt*y3;
       
      g.drawLine((int)lastx, (int)lasty, (int)x, (int)y);


      //      as mx (stability) changes, the line will get 'thicker'.
      lastx = x+mx*8;
      lasty = y+mx*8;
     }
	       


   }
}
