// the two squares in the background indicate mx and my.
// the line of rectangles flashes for t
// there is somewhat of a loop at 2.5f, but other parameters are
// also plain t based, so it changes slightly at each repetition.

import java.awt.*;
public class catherine_ps5_p2 extends mas110panel {
  Color black = new Color(0,0,0);
  Color white = new Color(1f, 1f, 1f);

   public void draw(Graphics g, float t) {

     float newt = t%3.5f;
     int rw = (int)(5*(1+Math.sin(0*newt*20)));
     int rh = (int)(20+Math.sin(0*newt*10));

     int rw1 = (int)(3+Math.sin(mx*newt*30));
     int rh1 = (int)(25+Math.sin(mx*newt*50));
     float sin1;
     float sin2;
     float factor;

     float j,k;

     g.setColor(black);
     g.fillRect(0,0,w,h);
     // i noticed that the black-backgrounded designs seemed to look the best
     // on the video wall.
     

       sin1 = 20*(float)Math.sin(newt*7);
       sin2 = 10*(float)Math.sin(newt*4);


     float time1 = .48f;
     float time2 = 1.2f;


     g.setColor(new Color(mx,mx,mx));
     g.fillRect((int)(mx*45), (int)((1-mx)*80+15), 20, 20);

     g.setColor(new Color(my,my,my));
     g.fillRect((int)(my*45+30), (int)((1-my)*80), 10, 30);

     for (j = 0; j < mx*20; j++) {
       g.setColor(new Color(t%1f, t%1f, t%1f));
       g.drawRect((int)(newt*mx*90), (int)(t*newt*j*(my+.5)), (int)(mx*30), 10);
     }

     g.setColor(new Color(1f, 1f, 1f));
       g.drawLine((int)(0), (int)(0), (int)(w), (int)(h));

     //this makes cool patterns for some mx and my.
     for (j = 0; j < 20; j++) {
       g.setColor(new Color(.24f+j*.03f, .24f+j*.03f, .24f+j*.03f));
       g.drawRect((int)(mx*j*5+t%7), (int)(10+t%34+(1-my)*80), (int)(10), (int)(70));
     }
	       

     if (newt < time1) {


       for(j=6*my;j>=0*my;j--){
	 sin1 = 20*(float)Math.sin(newt*7);
	 sin2 = 10*(float)Math.sin(newt*4);
       

       
	 g.setColor(new Color((5-j)*.2f,(5-j)*.2f, (5-j)*.2f));
	 g.fillRect((int)(60+newt*25+sin1+t-j*5*t/10f),(int)(10+newt*25+sin2+j*10),rw,rh);  //top
	 g.fillRect((int)(60-newt*25+sin1+t-j*5*t/10f),(int)(35-25*newt+sin2+j*10),rw,rh); //bottom
	 g.fillRect((int)(40+25*newt+sin1+t-j*5*t/10f),(int)(30+25*newt+sin2+j*10),rh,rw);  //left
	 g.fillRect((int)(65-25*newt+sin1+t-j*5*t/10f),(int)(30-25*newt+sin2+j*10),rh,rw); //right

       }
     }
     else if (newt < time2) {
     
       sin1 = 20*(float)Math.sin(newt*7)*0*t/5f;
       sin2 = 10*(float)Math.sin(newt*4)*0*t/5f;
       
       for(j=6*my;j>=0*my;j--){
	        
	 g.setColor(new Color((5-j)*.2f,(5-j)*.2f, (5-j)*.2f));
	 //       g.setColor(white);
       g.fillRect((int)(72-(newt-time1)*25+sin1-j*5*t/10f),(int)(j*10+22+(newt-time1)*25+sin2),rw,rh);  //top
       g.fillRect((int)(48+(newt-time1)*25+sin1-j*5*t/10f),(int)(j*10+23-25*(newt-time1)+sin2),rw,rh); //bottom
       g.fillRect((int)(53-25*(newt-time1)+sin1-j*5*t/10f),(int)(j*10+42-25*(newt-time1)+sin2),rh,rw);  //left
       g.fillRect((int)(53+25*(newt-time1)+sin1-j*5*t/10f),(int)(j*10+18+25*(newt-time1)+sin2),rh,rw); //right
     }
     }
     else {
       factor = (newt-time2)*(newt-time2);
       sin1 = 10*(float)Math.sin((newt-time2)*5);
       sin2 = sin1*factor;

       g.setColor(new Color(factor*2, factor*2, factor*2));
       for(int i=0; i<10; i++) {
	 g.fillRect((int)(i*30*factor), (int)(i*sin2*30), (int)(mx*5*i), (int)(mx*9));
       }


       for(j=6*my;j>=0;j--){
	        
	 g.setColor(new Color((5-j)*.2f,(5-j)*.2f, (5-j)*.2f));
	 
       g.fillRect((int)(56+sin1-j*5*t/10f),(int)(40+sin2+j*10),rw,rh);  //top
       g.fillRect((int)(66+sin1-j*t/2f),(int)(5+sin2+j*10),rw,rh); //bottom
       g.fillRect((int)(35+sin1-j*t/2f),(int)(24+sin2+j*10),rh,rw);  //left
       g.fillRect((int)(71+sin1-j*t/2f),(int)(36+sin2+j*10),rh,rw); //right


       /*
       g.fillRect((int)(42+sin1),(int)(10+12+factor*h),rw,rh);  //top
       g.fillRect((int)(30-12+sin1),(int)(35-12+factor*h),rw,rh); //bottom
       g.fillRect((int)(10+13+sin1),(int)(30+13+factor*h),rh,rw);  //left
       g.fillRect((int)(35-13+sin1),(int)(30-12+factor*h),rh,rw); //right
       */
     }
     }

   }
}
