// edit title: summer storm

// increased amplitude
// intricacy: more waves
// most comments interspersed with code.
// i want to see this on parametervision!
// i thought about adding contrasting rectangles, but decided to just
// frame the picture to give the lines context.

import java.awt.*;
public class catherine_ps5_p3 extends mas110panel {
   public void draw(Graphics g, float t) {
     double y = t % 2.5;

     // a darker background allows the non-black values to appear more
     // distinctly.

     // on second thought, let's just go black, to match the rest of my
     // problem set. we have to modify the colors more so we can see them.

     g.setColor(new Color(0.0f,0.0f,0.0f));
     g.fillRect(0,0,w,h);

     g.setColor(new Color(.23f, .23f, .23f));
     g.drawRect(10,10,80,80);

     g.setColor(new Color(.13f, .13f, .13f));
     g.drawRect(20,20,60,60);

     g.setColor(new Color(.06f, .06f, .06f));
     g.drawRect(30,30,40,40);

     int i;
     for (i=0;i<20;i++)
       {
	 g.setColor(new Color((float)(i/20f+.2f),(float)(i/20f+.2f),(float)(i/20f+.2f)));
	 g.drawLine((int)(50+35*(1+my*i/5)*Math.cos(2.512*(1+mx*0.5*i)*y)),
		    (int)(50+35*(1+my*i/5)*Math.sin(2.512*(1+mx*0.5*i)*y)),
		    (int)(50+35*(1+my*i/5)*Math.cos(2.512*(1+mx*0.5*i)*y)+
			  (20*Math.sin(10*y)*Math.sin(0.628*i))),
		    (int)(50+35*(1+my*i/5)*Math.sin(2.512*(1+mx*0.5*i)*y)+
			  (20*Math.sin(10*y)*Math.sin(0.628*i))));

	 // if mx is past a threshold value, create a second wave.

	 if (mx > .5f) {

	 g.setColor(new Color((float)(i*i/20f+.2f),(float)(i*i/20f+.2f),(float)(i*i/20f+.2f)));
	 g.drawLine((int)(50+35*(1+my*i/5)*Math.cos(-1*2.512*(1+mx*0.5*i)*(1-y)/5f)),
		    (int)(50+25*(1+my*i/5)*Math.sin(-1*2.512*(1+mx*0.5*i)*(1-y)/5f)),
		    (int)(50+35*(1+my*i/5)*Math.cos(-1*2.512*(1+mx*0.5*i)*(1-y)/5f)+
			  (10*Math.sin(10*y)*Math.sin(-1*0.628*i))),
		    (int)(50+25*(1+my*i/5)*Math.sin(-1*2.512*(1+mx*0.5*i)*(1-y)/5f)+
			  (10*Math.sin(10*y)*Math.sin(-1*0.628*i))));
	 }


	 // this inner curve slowed down looks really cool.

	 if (mx > .85f) {
	 g.setColor(new Color((float)((1-i)/20f+.2f),(float)((1-i)/20f+.2f),(float)((1-i)/20f+.2f)));
	 g.drawLine((int)(50+15*(1+my*i/5)*Math.cos(-1*2.512*(1+mx*0.5*i)*y/10f)),
		    (int)(50+15*(1+my*i/5)*Math.sin(-1*2.512*(1+mx*0.5*i)*y/10f)),
		    (int)(50+15*(1+my*i/5)*Math.cos(-1*2.512*(1+mx*0.5*i)*y/10f)+
			  (5*Math.sin(10*y)*Math.sin(-1*0.628*i))),
		    (int)(50+15*(1+my*i/5)*Math.sin(-1*2.512*(1+mx*0.5*i)*y/10f)+
			  (5*Math.sin(10*y)*Math.sin(-1*0.628*i))));
	 }


	 // okay i'll stop here. but one slow 'tail' in the middle
	 // seems like a worthwhile idea, after i saw the one right
	 // above.

	 if (mx > .95f) {
	 g.setColor(new Color((float)((i)/20f+.2f),(float)((i)/20f+.2f),(float)((i)/20f+.2f)));
	 g.drawLine((int)(50+5*(1+my*i/5)*Math.cos(1*2.512*(1+mx*0.5*i)*y/15f)),
		    (int)(50+5*(1+my*i/5)*Math.sin(1*2.512*(1+mx*0.5*i)*y/15f)),
		    (int)(50+5*(1+my*i/5)*Math.cos(1*2.512*(1+mx*0.5*i)*y/15f)+
			  (2*Math.sin(10*y)*Math.sin(-1*0.628*i))),
		    (int)(50+5*(1+my*i/5)*Math.sin(1*2.512*(1+mx*0.5*i)*y/15f)+
			  (2*Math.sin(10*y)*Math.sin(-1*0.628*i))));
	 }

       }   

   }
}
