// defs.h

// maximum number of SNPs that you will deal with in one haplotype.
#define MAXSNPS 2000

// number of chromosomes in sample
#define NUMCHROMS 100

// maximum haplotypes that you will observe
#define MAXHAPS 100


int blockarray[MAXSNPS/2][2];

// array of SNP positions
int snparray[MAXSNPS];

// array of haplotype data. each string in the allelearray is the
// chromosome data.
char* allelearray[MAXSNPS];

// same thing but for known snps data.
char* knownallelearray[MAXSNPS];

// array of known snp positions. indicies DO NOT correlate to snparray.
int knownSNParray[MAXSNPS];

// is 1 when we are using a known snp file.
int Known;

struct haplotype {
  char *hap;
  int count;
};

