#!/bin/csh

set modelstorun = "flat bneck bneck2"

foreach model ($modelstorun)

set filestorun = "0 1 2 3 4 5 6 7 8 9"

foreach filenum ($filestorun)

set snpfile = "$model.$filenum.tsc2.out"
set confile = "$model.$filenum.tsc2.conf"
set blockfile = "$model.$filenum.blocks"

echo $snpfile $confile $blockfile

../Programs/Confidence/LD-fast -I$snpfile -O$confile -P
../Programs/Blockfind/blockfind -d $confile -f $blockfile

end

end
