package ex5.backend;

import java.util.*;


public class MyPortfolioActionHandler implements PortfolioActionHandler {

 private Vector portfolios;

 public MyPortfolioActionHandler() {
 
  portfolios = new Vector();
  
 }

 public float getTickerPrice(String ticker) {
  return 1;
 }

 public boolean addStock(String ticker, int shares, float price, String
name) {
  int index = getPortfolioIndex(name);
  Vector pf = (Vector) portfolios.elementAt(index);
  Stock newstock = new MyStock(ticker, shares, price);
  pf.add(newstock);
  return true;
 }

 private int getStockIndex(int pfindex, String ticker) {
   Vector stocks = (Vector) portfolios.elementAt(pfindex);
   Iterator it = stocks.iterator();
   it.next(); //gets past name
   int counter = 1;
   Stock astock;
   
   for(;it.hasNext(); ) {
     astock = (Stock)it.next();
     if ((astock.getTicker()).equals(ticker))
       return counter;
     counter++;
   }
   return -1;
  
 }

 public boolean delStock(String ticker, String name) {
  int index = getPortfolioIndex(name);
  Vector pf = (Vector) portfolios.elementAt(index);
  
  int stockindex = getStockIndex(index, ticker);
  pf.remove(stockindex);
  return true;
 }

 public PortfolioView createPortfolio(String name) {

  Vector newfolio = new Vector();
  newfolio.add(name);

  portfolios.add(newfolio);

  return new MyPortfolioView(newfolio);
 }

 private int getPortfolioIndex(String name) {
  Vector pf;
  int counter = 0;
  for(Iterator it = portfolios.iterator(); it.hasNext(); counter++) {
    pf = (Vector)it.next();
    //    if(pf != null) 
    System.out.println((String)pf.elementAt(0));
    System.out.println(name);
    System.out.println(((String)pf.elementAt(0)).equals(name));
    if ((pf.elementAt(0)).equals(name))
      return counter;
  }
  return -1;
 }
   
 Vector getPortfolio(String name) {
  int index = getPortfolioIndex(name);

  if (index > -1)
   return (Vector) portfolios.elementAt(index);
  else return null;
 }

 public boolean closePortfolio(String name) {
  // pretned to close hte portfolio
  System.out.println("portfolio closed!");
  return true;
 }

  
  // mmm.. doesn't exist yet.
  public boolean openPortfolio(String name) {

    System.out.println("portfolio closed!");
    return true;
  }
  
}
