package ex5.backend;

import java.util.Vector;
import java.util.Iterator;


public interface PortfolioView {

  // @effects creates new PortfolioView with name pf, by requesting
  // portfolio from pah.
  // @return PortfolioView
  //  public PortfolioView(String pf, PortfolioActionHandler pah);

  // @return number of stocks in Portfolio
  public int numStocks();

  // @return name of Portfolio
  public String getName();


  // @return ticker of stock at index
  public String getTicker(int index);


  // @return number of shares of stock at index
  public int getShares(int index);

  // @return price of shares of stock at index
  public float getPrice(int index);

  // @effects creates new PortfolioView from portfolio
  // not a public method!
  // protected PortfolioView(Vector portfolio);

  // @return Iterator of stocks.
  public Iterator getIterator();
}  

