public interface RunState
{
  // does this really need to be public?
  // @effects: updates the RunState with the physics package.
  public void updatePhysics();


  // @return World which contains the current state of things
  // in the RunState.
  public World getWorld();


  // creates new, blank runstate.
  public RunState();

  // @effects: resets the RunState with new settings from the
  // Gizmo database.
  public void restart();
 
}
