import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import Playfield;

public class SpriteFarm extends Applet {
    Playfield playfield;
    Image output;
    int last_x, last_y;
    int count = 0;

    boolean dragback;
    public void init() {
	String backfile = getParameter("background");
      String s1file = getParameter("sprite1");
      String s2file = getParameter("sprite2");
	// String backfile = "shell.jpg";
        //   String s1file = "cowicon.gif";
	   //   String s2file = "tpicon.gif";
      showStatus("please wait while loading!");
      
      output = getImage(getDocumentBase(), backfile);
      Image s1 = getImage(getDocumentBase(), s1file);
      Image s2 = getImage(getDocumentBase(), s2file);

      playfield = new Playfield(output,2);

      output = playfield.toImage(this);
      showStatus("please wait just a little more!");
      playfield.addSprite(0, new Sprite(s1));
      showStatus("just a little bit more!");
      playfield.addSprite(1, new Sprite(s2));
      showStatus("now click away!");

    }

    public void paint(Graphics g) {
        g.drawImage(output, 0, 0, this);
        count += 1;
        showStatus("paint() called " + count + " time" + ((count > 1) ? "s":""));
    }
    
    public void update(Graphics g) {
      paint(g);
    }

    public boolean mouseUp(Event e, int x, int y) {
        //playfield.moveSprites(x, y);

	dragback = false;
	playfield.spritesmouseup(x,y);
        playfield.Draw();
        output = playfield.toImage(this);
        repaint();
        return true;
    }

    public boolean mouseDown(Event e, int x, int y) {
        last_x = x;
        last_y = y;
	if (playfield.anyTransparent(x,y))
	    dragback = true;
	else {
	    dragback = false;
	    playfield.spritesmousedown(x,y);
	}

        playfield.Draw();
	output = playfield.toImage(this);
	repaint();
        return true;
    }
    
    public boolean mouseDrag(Event e, int x, int y) {
	if (dragback)
	    playfield.scrollBackground(last_x-x, last_y -y);
	else
	    playfield.spritesmousedrag(x,y);

	last_x = x;
	last_y = y;
        playfield.Draw();
        output = playfield.toImage(this);
	repaint();
        return true;
    }
}
