import java.awt.*;
import java.awt.image.*;
import Raster;

class Sprite extends Raster {
   
    int x, y;                       // position of sprite on playfield
    //    public void Draw(Raster bgnd);  // draws sprite on a Raster
    int oldx, oldy;
    
    public Sprite(Image img) {
        super(img);
        x=0;
        y=0;
        oldx = 0;
        oldy = 0;

    }

    public void Draw(Playfield bgnd)
    {
        int wid = getWidth();
        int hei = getHeight();
        bgnd.refreshBackground(oldx, oldy, wid, hei);
        for (int w = 0; w<wid; w++) {
            for (int h = 0; h<hei; h++) {
                if(getPixel(w,h) < 0) 
                    bgnd.setPixel(getPixel(w,h), w+x, y+h);
                        }
        }
            oldx = x;
            oldy = y;
        
    }

}
